import 'package:comunic/ui/routes/create_account_route.dart';
import 'package:comunic/ui/routes/forgot_password_route.dart';
import 'package:comunic/ui/widgets/init_widget.dart';
import 'package:comunic/ui/widgets/login_scaffold.dart';
import 'package:comunic/ui/widgets/login_widget.dart';
import 'package:comunic/utils/intl_utils.dart';
import 'package:flutter/material.dart';

/// Login route
///
/// @author Pierre HUBERT

class LoginRoute extends StatefulWidget {
  @override
  State<StatefulWidget> createState() => _LoginRouteState();
}

class _LoginRouteState extends State<LoginRoute> {
  void _openCreateAccountPage() {
    Navigator.of(context)
        .push(MaterialPageRoute(builder: (c) => CreateAccountRoute()));
  }

  void _openResetPasswordPage() {
    Navigator.of(context)
        .push(MaterialPageRoute(builder: (c) => ForgotPasswordRoute()));
  }

  /// Build login form
  Widget _buildLoginForm() {
    return SingleChildScrollView(
      child: Padding(
        padding: const EdgeInsets.all(8.0),
        child: Column(
          children: <Widget>[
            LoginWidget(
              onSignedIn: () => Navigator.pushReplacement(context,
                  MaterialPageRoute(builder: (b) => InitializeWidget())),
            ),
            InkWell(
              child: Text(
                tr("Create an account"),
                style: TextStyle(color: Colors.blue.shade100),
              ),
              onTap: () => _openCreateAccountPage(),
            ),
            Container(height: 10),
            InkWell(
              child: Text(
                tr("Password forgotten"),
                style: TextStyle(color: Colors.blue.shade100),
              ),
              onTap: _openResetPasswordPage,
            ),
          ],
        ),
      ),
    );
  }

  @override
  Widget build(BuildContext context) => LoginScaffold(child: _buildLoginForm());
}
